#ifndef DISCRIMINANTFIT_H_
#define DISCRIMINANTFIT_H_
#include "../Individu/Genotype.h"

double minFitness=0;

template <class EOT>
class progressiveEvaluation : public eoEvalFunc<EOT>
{
public:
		/**
		 * constructeur par defaut vide
		 */
  progressiveEvaluation()
 
  {
   
  }
  int goalFluent(CPTFluentArray goal,CPTFluentArray state){
  	if(state.nb==0)return 0;
  	int nbGoal=0;
  	for(int i=0; i<goal.nb;i++){
  		for(int j=0;j<state.nb;j++){
  			if(cptGetIndexFromFluent(goal.elems[i])==cptGetIndexFromFluent(state.elems[j])){
  				nbGoal++;
  				break;
  			}
  		}
  	}
  	return nbGoal;
  }
  void printFluentArray(CPTFluentArray fluents)
				{
				  int i;
				  for (i = 0; i < fluents.nb; i++) {
				    CPTFluent fluent = fluents.elems[i];
				   
				    // affichage d'un fluent
				    cout << "FLUENT " << cptGetFluentName(fluent)<<"\n"; 
					 
				  }
				}
  
   void operator()(EOT & _eo)
  {
    
    if (_eo.invalid())
      {
      	 
      	 cptResetSearch();
      	 CPTSolutionPlan plan;
      	 CPTFluentArray goal = cptGetGoal();
      	 double fit=(double)global.getPenalite()*(global.stationMax*(10*goal.nb+11)); //nouvelle fitness	
      	 size_t totalBacktrack=0;
      	 double makespan=0;
      	 double GareUtile=0;
      	 double time,ptime,stime;
      	 int test=1;
      	 
      	if( _eo.getGenome().size()<=global.stationMax){
      	 for (size_t i = 0; i < _eo.getGenome().size(); i++) {
      	 	char *tmp[_eo.get(i).getGene().size()];
      	 	for(size_t j=0;j<_eo.get(i).getGene().size();j++){
					tmp[j]=new (nothrow) char[100];
					tmp[j]= cptGetFluentName(cptGetFluentFromIndex(_eo.get(i).getGene()[(int)j]));
				}
      	 	
			CPTFluentArray station = cptGetFluentArrayFromNames(tmp, _eo.get(i).getGene().size());
		    
		    global.setMaxb((CPTmaxbks()<100?10000:CPTmaxbks()));
		    
		     cptSetMaxBacktracks(global.getMaxb());
		     plan = cptSolveNext(station); 
		   plan = cptSolveNext(station); 
		     if (plan) {
		    	makespan+= cptGetMakespan(plan);
		    	if(cptGetMakespan(plan))++GareUtile;
		    	_eo.get(i).setbk(cptGetBacktracks(plan));
		    	totalBacktrack+=cptGetBacktracks(plan);
		    	time+=cptGetSearchTime(plan);
		    	
		    	if(fit<0){
		    		_eo.setPlan(plan);
		    	}
		   		
		    }
		    else{
		    	test=0; 
		       	_eo.setBreakStation(i+1);
		       	CPTFluentArray state= cptState();
		    	//fit=global.getPenalite()*(global.stationMax*(10*(goal.nb-goalFluent(goal,state))+11)- GareUtile);
		    	fit=global.getPenalite()*(global.stationMax*10*(global.stationMax- GareUtile+1)+(goal.nb-goalFluent(goal,state)));
		    	_eo.setPlan(plan);
		    	break;
		     }
		  }
		  
		  
		  
		   if(test) {
		   	_eo.setBreakStation(_eo.getGenome().size());
		   	 global.setMaxb((7*CPTmaxbks())<400?70*CPTmaxbks():7*CPTmaxbks());  
		     cptSetMaxBacktracks(global.getMaxb());
			plan = cptSolveNext(goal);
		     if (plan) {
			    	makespan+= cptGetMakespan(plan);
			    	_eo.setbackGoal(cptGetBacktracks(plan));
			    	totalBacktrack+=cptGetBacktracks(plan);
			    	time+=cptGetSearchTime(plan);
			    	
			    }
			    else{
			    	test=0; 
			    	_eo.setBreakStation(_eo.getGenome().size());
			    	_eo.setPlan(plan);
			       	CPTFluentArray state= cptState();
			    	fit=global.getPenalite()*(global.stationMax*(10*(goal.nb-goalFluent(goal,state))+11)- GareUtile);//CPTinformationDAE();
			    }
		   }
		   	  
		  if(test) {
		  
		  	unsigned cb=0;
		  	_eo.setBreakStation(_eo.getGenome().size());
		  	global.setMaxb(CPTmaxbks());
		    cptSetMaxBacktracks(global.getMaxb());
		   	plan = cptCompressSolution(false,false);
		  	
		  	if(!plan)
		  	{
		  		
		  		cptSetMaxBacktracks(global.getMaxb());
		  		plan = cptCompressSolution(false,true);
		  		if(!plan)
		  		{
		  			
		  			cptSetMaxBacktracks(global.getMaxb());
		  			plan = cptCompressSolution(true,true);
		  		}
		  	}
		  	
		  	if(plan){
		  		makespan+=cptGetMakespan(plan);
		  		time=cptGetTotalTime(plan);
		  		ptime=cptGetPreprocessingTime(plan);
		  		stime=cptGetSearchTime(plan);
		   		_eo.setDplan(cptGetMakespan(plan));
		   		cb+=cptGetBacktracks(plan);
		   		_eo.setcompressbk(cb);
		  		totalBacktrack+=cb;
		   		fit=cptGetMakespan(plan)+(_eo.getGenome().size()+1-GareUtile)*cptGetMakespan(plan)/(100*cptGetMakespan(plan))+totalBacktrack/10000;
		  		_eo.setPlan(plan);
		  		_eo.setBacktrack(totalBacktrack);
		  		_eo.setTime(time);
		  		_eo.setStime(stime);
		  		if(minFitness==0 || fit < minFitness){
		  				minFitness=fit;
		  			result=fopen(resultFile.c_str(),"wb");
		  			_eo.printPlanVal(result);
		  			fclose(result);
		  		
		   		}
		  	}
		  	else 
			{		  	
					
				CPTFluentArray state= cptState();
		    	fit=global.getPenalite()*(global.stationMax*(10*(goal.nb-goalFluent(goal,state)+100)+11)- GareUtile);
		  	
		  		_eo.setPlan(plan);
		  
			}
			
		  }
		  
		 
		  _eo.setTime(time);
		  _eo.setStime(stime);
		  
      	}
      	else fit=fit*2;  
		
		 
	_eo.fitness(fit);
      }
      
  }
  
};
#endif /*DISCRIMINANTFIT_H_*/
