#ifndef AJOUTDISCRIMINANT_H_
#define AJOUTDISCRIMINANT_H_

/**
 * @class eoCPTEO_V1AddMutation
 * @author Jacques Bibai
 * @brief definition d'un operateur de mutation : mutation permettant l'ajout d'une
 * gare.  
 */
template<class GenotypeT> 
class ajoutDeStation: public eoMonOp<GenotypeT>{
public:
	 /**
		 * Constructeur vide
		 */
  ajoutDeStation()
  {
    
  }
  
 
  
	string className() const { return "ajoutDeStation"; }

  /**
   * @fn bool operator()(GenotypeT &)
   * @brief Operateur decrivant la maniere d'effectuer une mutation par ajout de gare. 
   * Ici on tire aleatoirement une gare. Ensuite on insere cette une gare construite a cette place.  
   * @param individu instance de la classe GenotypeT
   * @return bool : vrai si l'operation a reussi et faux sinon
   */ 
  bool operator()(GenotypeT & _genotype)
  {

     bool isModified=false;
     int which,pos=0;
	// which =rng.random( _genotype.getBreakStation());
	if(_genotype.getGenome().size()<_genotype.getBreakStation()) which= _genotype.getBreakStation();
	else if(_genotype.getBreakStation()==1) which= _genotype.getBreakStation();
	else  which =rng.random(_genotype.getBreakStation());
	 Gene station;
	// cout << " \n ***************before add mut ****************\n" << _genotype;   
    if(which>0 && which < (int)_genotype.getGenome().size() )
    { 
    	//sauvegarde et initialisation du genotype
    	// definition des ensembles mutex, intersection et difference
    	std::vector<int> mutexF;
    	std::vector<int> mutexS;
    	std::vector<int> intersection;
    	std::vector<int> minus;
    	mutexF.resize(_genotype.get(which-1).size()>_genotype.get(which).size()?_genotype.get(which).size():_genotype.get(which-1).size());
		mutexS.resize(_genotype.get(which-1).size()>_genotype.get(which).size()?_genotype.get(which).size():_genotype.get(which-1).size());
		intersection.resize(_genotype.get(which-1).size()>_genotype.get(which).size()?_genotype.get(which).size():_genotype.get(which-1).size());
		minus.resize(_genotype.get(which).size());
		//definition et initialisation des variables contenant les tailles reelles des differents ensembles
		int fMutex=0,inter=0,moins=0;
		//initialisation des differents ensembles
		for(size_t i=0;i<_genotype.get(which).size();i++)
		{
			if(_genotype.get(which-1).mutex(_genotype.get(which).get(i),_genotype.get(which-1).size()))
			{
				mutexF[fMutex]=_genotype.get(which-1).mutex(_genotype.get(which).get(i),_genotype.get(which-1).size());
				mutexS[fMutex]=_genotype.get(which).mutex(mutexF[fMutex],_genotype.get(which).size());
				fMutex++;
			}
			else if(_genotype.get(which-1).exist(_genotype.get(which).get(i))>0)
				{
					intersection[inter]=_genotype.get(which).get(i);
					inter++;
				}
				else
				{
					minus[moins]=_genotype.get(which).get(i);
					moins++;
				}
		}
		//verification de l'egalite entre les deux stations
		if(fMutex==0 && moins==0) return false;
		//sauvegarde des gares 
    	std::vector<Gene> tmp;
	    tmp.resize(_genotype.getGenome().size());
	    for(size_t i=0;i<tmp.size();i++){
		   		tmp[i].getGene().resize(_genotype.get(i).size());
		   		 for(size_t j=0;j<tmp[i].size();j++){
		   		 	tmp[i].set(j,_genotype.get(i).get(j));
		   		 }
		   		 _genotype.get(i).getGene().clear();
		   	}
	     _genotype.getGenome().clear();
		 _genotype.getGenome().resize(tmp.size()+1);
		 // fin de la reinitialisation et sauvegarde du genotype  
	     /*******************************************************
	      *														* 
	      * debut de construction de la station intermediare	*
	      * 													*
	      *******************************************************/
		   // choix de la taille 
			//station.getGene().resize(inter+fMutex+rng.random(moins));
			// fin du choix de la taille
			//construction de la station
			//fluents de l'intersection 
			   for(size_t i=0;i<(size_t)inter;i++){
			   	   		station.getGene().push_back(intersection[i]);
			   }
			//fluents mutex proba=1/2
			for(size_t i=0;i<(size_t)fMutex;i++)
			   {
			   		if(rng.flip(0.5)&& station.mutex2(mutexF[i],station.size())==0
					 && station.notExist(mutexF[i]))station.getGene().push_back(mutexF[i]);
			   		else if(station.mutex2(mutexS[i],station.size())==0
			   		&& station.notExist(mutexS[i]))station.getGene().push_back(mutexS[i]);
			   }  
			 //reste fluents
			  for(size_t i=0;(int)i<moins;i++)
			   {
			   		if(rng.flip(0.5)&& station.mutex2(minus[i],station.size())==0
					 && station.notExist(minus[i]))station.getGene().push_back(minus[i]);
			   		
			   		
			   }
			    int ho;
	 	if(rng.flip(global.getpMeanAveragePerMutation()/tmp.size())){
	 		CPTPredicateArray preds = cptGetPredicates();
  			std::vector<unsigned>jeu;
  			jeu.resize(global.getPredicateSize());
  			//initialisation avec la valeur exacte de la table des predicats
  			for(size_t i=0;i<jeu.size();i++) 
  			{	size_t j;
  				for(j=0;j<(unsigned)preds.nb;j++)
  					if(strcmp(cptGetPredicateName(preds.elems[j]),global.getPredicate(i).c_str())==0)break;
  				jeu[i]=j;
  			}
  			unsigned posPredicate, plus=eo::rng.random(global.getDistance());
  			bool test;
  			for(size_t j=0;j<plus;j++)
			{
				ho=0;
				do
				{
					test=false;
					//choix du predicat 
					posPredicate=rng.random(jeu.size());
					//debut tirage aleatoire de termes 
					//	cout << posPredicate << "***************\n";				
					std::vector<CPTTermArray> terms;
			    	terms.resize(cptGetArity(preds.elems[jeu[posPredicate]]));
			    	//initialisation de la table des termes
			    	for(size_t k=0; k<terms.size();k++){
			    		terms[k]=cptGetPossibleTerms(preds.elems[jeu[posPredicate]],k);
			    	}
			    	// choix des termes
			    	std::vector<CPTTerm> argument;
			    	argument.resize(terms.size());
			    	for(size_t k=0;k<argument.size();k++)
			    	{
			    		argument[k]=terms[k].elems[rng.random(terms[k].nb)];
			    	}
			    	
			    	// construction du fluent correspondant 
			    	std::string fluentChar("(");
			    	fluentChar+=cptGetPredicateName(preds.elems[jeu[posPredicate]]);
			    	
			    	for(size_t k=0;k<argument.size();k++)
			    	{
			    		fluentChar+=" ";
			    		fluentChar+=cptGetTermName(argument[k]);
			    		
			    	}
			    	fluentChar+=")";
			    	//cout << fluentChar.c_str();
			    	CPTFluent fluent=cptGetFluentFromName((char *)fluentChar.c_str());
			    	if(fluent!=NULL)
			    	{
			    		
			    		if(station.size()< 100 && station.mutex2(cptGetIndexFromFluent(fluent),station.size())==0
			    		 && station.notExist(cptGetIndexFromFluent(fluent))){
			    		 	station.getGene().push_back(cptGetIndexFromFluent(fluent));
			    		 }
			    		else test=true;
			    		
			    		ho++;
			    	}
			    	else test=true;
				}while(test && !ho==10);
			}
	 	}    
			   
			 /*******************************************************
		      *														* 
		      *		 debut de construction du genotype				*
		      * 													*
		      *******************************************************/
		      pos=0;
			   for(size_t i=0;i<tmp.size();i++){
			   		if((int)i==which){
			   			_genotype.set(pos,station);
			   			pos++;
			   		}
			   		_genotype.set(pos,tmp[i]);
			   		tmp[i].getGene().clear();
			   		pos++;
			   		
			   	}
			   isModified=true;	
			   tmp.clear();
			   //cout << station << "***************\n";	
			   station.getGene().clear();
    }

    else {
    	//sauvegarde et initialisation du genotype
    	if(which!=(int)_genotype.getGenome().size())which=0;
    	else which=_genotype.getGenome().size()-1;		
		std::vector<Gene> tmp;
   		tmp.resize(_genotype.getGenome().size());
    	for(size_t i=0;i<tmp.size();i++){
	   		tmp[i].getGene().resize(_genotype.get(i).size());
	   		 for(size_t j=0;j<tmp[i].size();j++){
	   		 	tmp[i].set(j,_genotype.get(i).get(j));
	   		 }
	   		 _genotype.get(i).getGene().clear();
	   	}
    	_genotype.getGenome().clear();
	 	_genotype.getGenome().resize(tmp.size()+1);
	 	Gene stationNew;
	 	
	 	for(size_t i=0;i<tmp[which].size();i++){
	 		if(rng.flip(0.5)){
	 			stationNew.getGene().push_back(tmp[which].get(i));
	 			
	 		}
	 	}
	 	if(stationNew.size()==tmp[which].size() && tmp[which].size()>1 )stationNew.getGene().pop_back();
	 	if(stationNew.size()==0)stationNew.getGene().push_back(tmp[which].get(eo::rng.random(tmp[which].size())));
	 	int ho;
	 	if(rng.flip(global.getpMeanAveragePerMutation()/tmp.size())){
	 		CPTPredicateArray preds = cptGetPredicates();
  			std::vector<unsigned>jeu;
  			jeu.resize(global.getPredicateSize());
  			//initialisation avec la valeur exacte de la table des predicats
  			for(size_t i=0;i<jeu.size();i++) 
  			{	size_t j;
  				for(j=0;j<(unsigned)preds.nb;j++)
  					if(strcmp(cptGetPredicateName(preds.elems[j]),global.getPredicate(i).c_str())==0)break;
  				jeu[i]=j;
  			}
  			unsigned posPredicate, plus=1+ eo::rng.random(global.getDistance());
  			bool test;
  			for(size_t j=0;j<plus;j++)
			{
				ho=0;
				do
				{
					test=false;
					//choix du predicat 
					posPredicate=rng.random(jeu.size());
					//debut tirage aleatoire de termes 
					//	cout << posPredicate << "***************\n";				
					std::vector<CPTTermArray> terms;
			    	terms.resize(cptGetArity(preds.elems[jeu[posPredicate]]));
			    	//initialisation de la table des termes
			    	for(size_t k=0; k<terms.size();k++){
			    		terms[k]=cptGetPossibleTerms(preds.elems[jeu[posPredicate]],k);
			    	}
			    	// choix des termes
			    	std::vector<CPTTerm> argument;
			    	argument.resize(terms.size());
			    	for(size_t k=0;k<argument.size();k++)
			    	{
			    		argument[k]=terms[k].elems[rng.random(terms[k].nb)];
			    	}
			    	
			    	// construction du fluent correspondant 
			    	std::string fluentChar("(");
			    	fluentChar+=cptGetPredicateName(preds.elems[jeu[posPredicate]]);
			    	
			    	for(size_t k=0;k<argument.size();k++)
			    	{
			    		fluentChar+=" ";
			    		fluentChar+=cptGetTermName(argument[k]);
			    		
			    	}
			    	fluentChar+=")";
			    	//cout << fluentChar.c_str();
			    	CPTFluent fluent=cptGetFluentFromName((char *)fluentChar.c_str());
			    	if(fluent!=NULL)
			    	{
			    		
			    		if(stationNew.size()< 100 && stationNew.mutex2(cptGetIndexFromFluent(fluent),stationNew.size())==0
			    		 && stationNew.notExist(cptGetIndexFromFluent(fluent))){
			    		 	stationNew.getGene().push_back(cptGetIndexFromFluent(fluent));
			    		 }
			    		else test=true;
			    		
			    		ho++;
			    	}
			    	else test=true;
				}while(test && !ho==10);
			}
	 	}
	 	
	 	if(which==0){
	 		_genotype.set(which,stationNew);
	 		for(size_t i=0;i<tmp.size();i++){
	   		 	_genotype.set(i+1,tmp[i]);
	   		}
	 	}
	 	else{
	 		_genotype.set(which+1,stationNew);
	 		for(size_t i=0;i<tmp.size();i++){
		   		 _genotype.set(i,tmp[i]);
		   	}
	 	}
	    if(tmp.size()!=0)tmp.clear();
		stationNew.getGene().clear();
		isModified=true;	
    	
    }	
		   
    
    
   
   return  isModified;


}
};
#endif /*AJOUTDISCRIMINANT_H_*/
